/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC15F4K60S4 系列 定时器2用作串口1的波特率发生器举例------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966-------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.GXWMCU.com --------------------------------------------*/
/* 如果要在程序中使用此代码,请在程序中注明使用了STC的资料及程序        */
/* 如果要在文章中应用此代码,请在文章中注明使用了STC的资料及程序        */
/*---------------------------------------------------------------------*/

//本示例在Keil开发环境下请选择Intel的8058芯片型号进行编译
//若无特别说明,工作频率一般为22.0592MHz

/*
*WiFi工作就绪时3个灯同时亮
*WiFi连上网绿灯亮
*WiFi配网时红灯亮
*按下k2按键进行配网

*/
#include <stdlib.h>
#include "UART.H"
#include "string.h"
#include "SYS.H"
#include "pwm.h"
WIFI_STATE=WIFI_IDLE;
int config=1;
int btn_state=0;
int deal_data(char *str)
{
	switch(WIFI_STATE){
	case WIFI_IDLE://esp8266就绪
		Delay2(1);
		if(strstr(str,READY)!=NULL)
		{
			PWM(99,99,99);
			WIFI_STATE=CLOUD_START;
		}
		break;
	case CLOUD_START://开始连接AICLOUD2.0
		Delay2(3);
		if(strstr(str,wifi_code)!=NULL)
		{
			btn_state=1;
			PWM(1,99,1);
			WIFI_STATE=CLOUD_CONNECTED;
			at_uart_send_str(AT_CLDSTART);
		}else	if(strstr(str,smartlink_code)!=NULL){
			WIFI_STATE=CLOUD_SMARTLINK;
		}
		break;
		case CLOUD_CONNECTED://连接AICLOUD成功
			config=1;
		//at_uart_send_str("CLOUD_CONNECTED");
		if(strstr(str,cloud_connected)!=NULL)
		{
			WIFI_STATE=CLOUD_TRANSMIT;
				PWM(1,1,99);
		}
			break;
		case CLOUD_TRANSMIT://开始传输数据
			Delay2(3);
			if(strstr(str,RGB)!=NULL)//解析RGB数据
			{
				char buf[30],R[5],G[5],B[5];
				int r=0,g=0,b=0;
				Delay2(1);
				strtok(str,":");
				Delay2(1);
				 strtok(NULL,":");
				Delay2(1);
				strcpy(buf,strtok(NULL,":"));
				strcpy(R,strtok(buf,","));
				Delay2(1);
				strcpy(G,strtok(NULL,","));
				strcpy(B,strtok(NULL,"\r"));
				r=atoi(R);
				g=atoi(G);
				b=atoi(B);	
				Delay2(1);
				PWM(r,b,g);
			}else if(strstr(str,smartlink_code)!=NULL)
			{
				WIFI_STATE=CLOUD_SMARTLINK;
					PWM(99,1,1);
			}
			break;
		case CLOUD_SMARTLINK://开始配网
			
			if(strstr(str,smartlink_code)!=NULL)
			{
				PWM(99,1,1);
				}else if(strstr(str,cloud_connected)!=NULL){
					PWM(1,1,99);
					WIFI_STATE=CLOUD_TRANSMIT;
				}
			break;
			case CLOUD_DISCONN:
				Delay2(1);
				if(strstr(str,cloud_connected)!=NULL)
				{
					PWM(1,1,99);
					WIFI_STATE=CLOUD_TRANSMIT;
				}
				break;
	default :
		break;
	}
	
	return 0; 
}


void main()
{
   init_uart();// 初始化串口
	//PWM(55,55,1);
	WIFI_VCC=0;		   //
	BEEP=0;
		Delay2(50);
  // SendString("at\r\n");
//		at_uart_send_str(AT_CLDSTART);
		memset(rec_buf,0,80);
    while(1)
		{
			
			if(busy==1)
			{
				
				busy=0;
				//SendString(rec_buf);
				deal_data(rec_buf);
				memset(rec_buf,0,80);
				rec_count=0;
			}
			if((K1==0)&&(config==1))//k2按键被按下
			{
				Delay2(500);
				if((K1==0)&&(config==1))
				{
					config=0;
					at_uart_send_str(AT_SMARTLINK);
					LED2=1;
					if(btn_state==1)
					{
					PWM(99,1,99);
						WIFI_STATE=CLOUD_SMARTLINK;
					}else{
					PWM(99,1,1);
						WIFI_STATE=CLOUD_START;
						}
				}
			}
			
		}
}

