
#include "reg51.h"
#include "intrins.h"
#include "pwm.h"
#define FOSC    11059200L

typedef unsigned char BYTE;
typedef unsigned int WORD;

sfr P_SW1       = 0xA2;             //蹦лĴ1

#define CCP_S0 0x00                 //P_SW1.4
#define CCP_S1 0x20                 //P_SW1.5

sfr CCON        =   0xD8;           //PCAƼĴ
sbit CCF0       =   CCON^0;         //PCAģ0жϱ־
sbit CCF1       =   CCON^1;         //PCAģ1жϱ־
sbit CR         =   CCON^6;         //PCAʱпλ
sbit CF         =   CCON^7;         //PCAʱ־
sfr CMOD        =   0xD9;           //PCAģʽĴ
sfr CL          =   0xE9;           //PCAʱֽ
sfr CH          =   0xF9;           //PCAʱֽ
sfr CCAPM0      =   0xDA;           //PCAģ0ģʽĴ
sfr CCAP0L      =   0xEA;           //PCAģ0Ĵ LOW
sfr CCAP0H      =   0xFA;           //PCAģ0Ĵ HIGH
sfr CCAPM1      =   0xDB;           //PCAģ1ģʽĴ
sfr CCAP1L      =   0xEB;           //PCAģ1Ĵ LOW
sfr CCAP1H      =   0xFB;           //PCAģ1Ĵ HIGH
sfr CCAPM2      =   0xDC;           //PCAģ2ģʽĴ
sfr CCAP2L      =   0xEC;           //PCAģ2Ĵ LOW
sfr CCAP2H      =   0xFC;           //PCAģ2Ĵ HIGH
sfr PCA_PWM0    =   0xf2;           //PCAģ0PWMĴ
sfr PCA_PWM1    =   0xf3;           //PCAģ1PWMĴ
sfr PCA_PWM2    =   0xf4;           //PCAģ2PWMĴ

void PWM(unsigned char r,unsigned char g,unsigned char b)
{ 
    P_SW1|=0x20;
    P_SW1&=0xef;
    CCON = 0;                       //ʼPCAƼĴ
    CL = 0;                         //λPCAĴ
    CH = 0;
    CMOD = 0x02;                    //PCAʱԴ
                                    //ֹPCAʱж
    PCA_PWM0 = 0x00;                //PCAģ08λPWM
    CCAP0H = CCAP0L = r;         //PWM0ռձΪ87.5% ((100H-20H)/100H)
    CCAPM0 = 0x42;                  //PCAģ0Ϊ8λPWMģʽ

    PCA_PWM1 = 0x00;                //PCAģ17λPWM
    CCAP1H = CCAP1L = g;         //PWM1ռձΪ75% ((80H-20H)/80H)
    CCAPM1 = 0x42;                  //PCAģ1Ϊ7λPWMģʽ

    PCA_PWM2 = 0x00;                //PCAģ26λPWM
    CCAP2H = CCAP2L = b;         //PWM2ռձΪ50% ((40H-20H)/40H)
    CCAPM2 = 0x42;                  //PCAģ2Ϊ6λPWMģʽ

    CR = 1;                         //PCAʱʼ
}
/*
void set_pwm(unsigned char data rr,unsigned char data gg,unsigned char data bb)
{
    CCAP0H = CCAP0L = rr;         //PWM0ռձΪ87.5% ((100H-20H)/100H)

              //PCAģ17λPWM
    CCAP1H = CCAP1L = gg;         //PWM1ռձΪ75% ((80H-20H)/80H)
              //PCAģ1Ϊ7λPWMģʽ

    CCAP2H = CCAP2L = bb;         //PWM2ռձΪ50% ((40H-20H)/40H)
                 //PCAģ2Ϊ6λPWMģʽ
}
*/

